public class TrainSim extends RailwayNetwork {


///////////////////////////////////////////////////////////////////

    public static void main(String args[]) {

	/////////////////////////////////////////////////////////
        // setup the railway network
        /////////////////////////////////////////////////////////

       /*--- first the isolated segments ---*/
	Segment s11 = new Segment("s11",LONG);
        Segment s12 = new Segment("s12",LONG);
        Segment s13 = new Segment("s13",LONG);
        Segment s14 = new Segment("s14",LONG);
        Segment s15 = new Segment("s15",LONG);
        Segment s16 = new Segment("s16",LONG);
        Segment s21 = new Segment("s21",LONG);
        Segment s22 = new Segment("s22",LONG);
        Segment s23 = new Segment("s23",LONG);
        Segment s24 = new Segment("s24",LONG);
        Segment s25 = new Segment("s25",LONG);
        Segment s31 = new Segment("s31",LONG);
        Segment s32 = new Segment("s32",LONG);
        Segment s33 = new Segment("s33",LONG);
        Segment sa = new Segment("sa",SHORT);
        Segment sb = new Segment("sb",SHORT);
        Segment sc = new Segment("sc",SHORT);
        Segment sd = new Segment("sd",SHORT);
        Segment se = new Segment("se",SHORT);

	/*--- now connect the segments ---*/
        s11.setNeighbour(RIGHT,s12);
        s12.setNeighbour(LEFT,s11);
        s12.setNeighbour(RIGHT,s13);
        s13.setNeighbour(LEFT,s12);
        s13.setNeighbour(RIGHT,s14);
        s14.setNeighbour(LEFT,s13);
        s14.setNeighbour(RIGHT,s15);
        s15.setNeighbour(LEFT,s14);
        s15.setNeighbour(RIGHT,s16);
        s16.setNeighbour(LEFT,s15);
        s21.setNeighbour(RIGHT,s22);
        s22.setNeighbour(LEFT,s21);
        s22.setNeighbour(RIGHT,sd);
        s23.setNeighbour(LEFT,se);
        s23.setNeighbour(RIGHT,s24);
        s24.setNeighbour(LEFT,s23);
        s24.setNeighbour(RIGHT,s25);
        s25.setNeighbour(LEFT,s24);
        s31.setNeighbour(RIGHT,s32);
        s32.setNeighbour(LEFT,s31);
        s32.setNeighbour(RIGHT,s33);
        s33.setNeighbour(LEFT,s32);
        sa.setNeighbour(LEFT,s32);
        sa.setNeighbour(RIGHT,se);
        sb.setNeighbour(LEFT,s11);
        sb.setNeighbour(RIGHT,sd);
        sc.setNeighbour(LEFT,se);
        sc.setNeighbour(RIGHT,s14);
        sd.setNeighbour(LEFT,s22);
        sd.setNeighbour(RIGHT,se);
        se.setNeighbour(LEFT,sd);
        se.setNeighbour(RIGHT,s23);

        /*--- set all points straight ---*/
        Point w11 = new Point("w11",s11,RIGHT,s12,sb);
        Point w12 = new Point("w12",s14,LEFT,s13,sc);
        Point w21 = new Point("w21",sd,LEFT,s22,sb);
        Point w22 = new Point("w22",se,LEFT,sd,sa);
        Point w23 = new Point("w23",se,RIGHT,s23,sc);
        Point w31 = new Point("w31",s32,RIGHT,s33,sa);


        // one train which is stopped completly
        Train t1 = new Train("t1",s11,NO_DIR);

        // two trains which drive around the network
        Train t2 = new Train("t2",s25,LEFT);
        Train t3 = new Train("t3",s31,RIGHT); 
        Train t4 = new Train("t4",s16,LEFT);
        new Thread(t2).start();
        new Thread(t3).start();
        new Thread(t4).start();

        // points are switching arbitrarily in parallel
        new Thread(w11).start();
        new Thread(w12).start();
        new Thread(w21).start();
        new Thread(w22).start();
        new Thread(w23).start();
        new Thread(w31).start();


 

    }

}
