public class Point implements Runnable {

    String pointId;
    Segment rootSegment;
    int     directionFromRootSegment;
    Segment pointsTo;
    Segment otherEnd;

    public Point(String ptId, Segment root, int dir, 
                 Segment toseg, Segment othseg) {
	pointId = ptId;
	rootSegment = root;
	pointsTo = toseg;
        otherEnd = othseg;
        directionFromRootSegment = dir;
	if ( rootSegment != null ) 
	    rootSegment.setNeighbour
               (directionFromRootSegment,pointsTo);
    }

    public String toString() { return pointId; }

    public synchronized void setPoint(Segment seg) {
	if ( seg == otherEnd ) {
	    otherEnd = pointsTo;
	    pointsTo = seg;
	    if ( rootSegment != null ) 
		rootSegment.setNeighbour
		    (directionFromRootSegment,pointsTo);
	}
    }

    public void run() {

	while (true) {
	    try { Thread.sleep((int)(20000+10000*Math.random())); }
            catch (InterruptedException e) { e.printStackTrace(); }
            // random decision for switching
            if ( Math.random() < 0.5 ) 
		setPoint(otherEnd);
	}

    }

}
